<?php
class ControllerShippingmahacodshipping extends Controller {
	private $error = array(); 
	/****************************************************************************/	
	public function index() {   
		/* Language */
		$this->load->language('shipping/mahacod_shipping');
		$this->document->setTitle($this->language->get('heading_title'));
		/* Model */
		$this->load->model('setting/setting');
		$this->load->model('localisation/tax_class');
		$this->load->model('localisation/geo_zone');
		/* (Update) */
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('mahacod_shipping', $this->request->post);		
			$this->session->data['success'] = $this->language->get('text_success');
			$this->redirect($this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'));
		}
		$this->data['heading_title'] = $this->language->get('heading_title');
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['entry_username'] = $this->language->get('entry_username');
		$this->data['entry_cost'] = $this->language->get('entry_cost');
		$this->data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['tab_general'] = $this->language->get('tab_general');
		/* Warnings */
		$this->data['error_warning'] = isset($this->error['warning']) ? $this->error['warning'] : '';
		/* Breadcrumbs */
		$this->data['breadcrumbs'] = array();
   		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'), 'separator' => false);
   		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_shipping'), 'href' => $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'), 'separator' => ' :: ');
   		$this->data['breadcrumbs'][] = array('text' => $this->language->get('heading_title'), 'href' => $this->url->link('shipping/mahacod_shipping', 'token=' . $this->session->data['token'], 'SSL'), 'separator' => ' :: ');
		/* Actions */
		$this->data['action'] = $this->url->link('shipping/mahacod_shipping', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');
		/* (Fields)->Shipping */
		$this->data['mahacod_shipping_geo_zone_id'] = isset($this->request->post['mahacod_shipping_geo_zone_id']) ? $this->request->post['mahacod_shipping_geo_zone_id'] : $this->config->get('mahacod_shipping_geo_zone_id');
		$this->data['mahacod_shipping_status'] = isset($this->request->post['mahacod_shipping_status']) ? $this->request->post['mahacod_shipping_status'] : $this->config->get('mahacod_shipping_status');
		$this->data['mahacod_shipping_sort_order'] = isset($this->request->post['mahacod_shipping_sort_order']) ? $this->request->post['mahacod_shipping_sort_order'] : $this->config->get('mahacod_shipping_sort_order');
		/* DataRows */
		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		/* Template */
		$this->template = 'shipping/mahacod_shipping.tpl';
		$this->children = array('common/header', 'common/footer');		
		$this->response->setOutput($this->render());
	}
	/****************************************************************************/	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/mahacod_shipping')) { $this->error['warning'] = $this->language->get('error_permission'); }
		return !$this->error ? true : false;
	}
}
?>