<?php

/* Posts WebService Pro v6.2 */

require_once(DIR_SYSTEM . 'library/nuSoap/nusoap.php');

class Controllerpaymentmahacodpayment extends Controller {
	private $WebService = array();
	private $errors = array();
	/*********************************************************/
	public function index() {
		/* Language */
		$this->language->load('payment/mahacod_payment');
		/* Texts */
		$this->data['text_wait'] = $this->language->get('text_wait');
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_connect'] = $this->language->get('button_connect');
		$this->data['button_working'] = $this->language->get('button_working');
		/* Template */
		$maha_template =  '/template/payment/mahacod_payment_checkout.tpl';
		$this->template = file_exists(DIR_TEMPLATE . $maha_template) ? $this->config->get('config_template').$maha_template:'default'.$maha_template;
		$this->render();
	}
	/*********************************************************/
	public function info() {
		$this->language->load('payment/mahacod_payment');
		$this->document->setTitle($this->language->get('text_info'));
		$this->data['text_info'] = $this->language->get('text_info');
		$this->data['button_continue'] = $this->language->get('button_continue');
		$this->data['button_back'] = $this->language->get('button_back');
		$this->data['entry_ostan'] = $this->language->get('entry_ostan');
		$this->data['entry_shahrestan'] = $this->language->get('entry_shahrestan');
		/* breadcrumbs */
		$this->data['breadcrumbs'] = array();
      	$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_home'),'href' => $this->url->link('common/home'),'separator' => false); 
      	$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_basket'),'href' => $this->url->link('checkout/cart'),'separator' => $this->language->get('text_separator'));
      	$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_info'), 'href' => $this->url->link('payment/mahacod_payment/info', '', 'SSL'), 'separator' => $this->language->get('text_separator'));
		/* URL Set */
		$this->data['back_url'] = $this->url->link('checkout/cart');
		$this->data['continue'] = $this->url->link('common/home', '', 'SSL');
		$this->data['action'] = $this->url->link('payment/mahacod_payment/info', '', 'SSL');
		$this->data['checkout'] = $this->url->link('checkout/checkout', '', 'SSL');		
		/* Update Setting */
		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if (empty($this->request->post['ostan'])) { $this->errors['ostan_id'] = $this->language->get('error_ostan_empty'); }
			if (empty($this->request->post['shahrestan'])) { $this->errors['shahrestan_id'] = $this->language->get('error_shahrestan_empty'); }
			if (count($this->errors) == 0) {
				$this->session->data['ostan_id'] = $this->request->post['ostan'];
				$this->session->data['shahrestan_id'] = $this->request->post['shahrestan'];
				$this->redirect($this->url->link('checkout/checkout', '&info=true', 'SSL'));
			}
		}
		$this->data['ostan_id'] = isset($this->session->data['ostan_id']) ? $this->session->data['ostan_id'] : '';
		$this->data['shahrestan_id'] = isset($this->session->data['shahrestan_id']) ? $this->session->data['shahrestan_id'] : '';
		$this->data['error_ostan_id'] = isset($this->errors['ostan_id']) ? $this->errors['ostan_id'] : '';
		$this->data['error_shahrestan_id'] = isset($this->errors['shahrestan_id']) ? $this->errors['shahrestan_id'] : '';
		$this->data['data_ostan'] = $this->get_ostan(true, $this->data['ostan_id']);
		$this->data['data_shahrestan'] = $this->get_shahrestan(true, $this->data['shahrestan_id']);		
		$this->children = array(
			'common/column_left',
			'common/column_right',
			'common/content_top',
			'common/content_bottom',
			'common/footer',
			'common/header'
		);
		$maha_template =  '/template/payment/mahacod_payment_form.tpl';
		$this->template = file_exists(DIR_TEMPLATE . $maha_template) ? $this->config->get('config_template').$maha_template:'default'.$maha_template;
		$this->response->setOutput($this->render());
	}
	/*********************************************************/
	public function get_ostan($return = false, $corrent_ostan = "") {
		$ostan_id = isset($this->request->get['ostan_id']) ? (int)$this->request->get['ostan_id'] : ($corrent_ostan ? $corrent_ostan : '');
		$this->Connect();
		$this->data['WebService']['get_ostan'] = $this->WebService->get_ostan($ostan_id);
		if ($return) {
			return $this->data['WebService']['get_ostan'];
		} else {
			$this->response->setOutput($this->data['WebService']['get_ostan']);
			$this->response->output();
			$this->response->setOutput('');
		}
	}
	/*********************************************************/
	public function get_shahrestan($return = false, $corrent_shahrestan = '') {
		$this->Connect();
		$this->data['WebService']['get_shahrestan'] = $this->WebService->get_shahrestan($corrent_shahrestan);
		if ($return) {
			return $this->data['WebService']['get_shahrestan'];
		} else {
			$this->response->setOutput($this->data['WebService']['get_shahrestan']);
			$this->response->output();
			$this->response->setOutput('');
		}
	}
	/*********************************************************/
	public function Connect() {
		$this->load->library('MahaCOD-CashOnDelivery/MahaCOD.class');
		$this->WebService = new Mahacod();
		$this->WebService->data['Config']['Shop_id'] = $this->data['WebService']['Shop_id'] = $this->config->get('mahaposts_co_id');
		$this->WebService->data['Config']['Username'] = $this->data['WebService']['Username'] = $this->config->get('mahaposts_username');
		$this->WebService->data['Config']['Password'] = $this->data['WebService']['Password'] = $this->config->get('mahaposts_password');
		$this->WebService->data['Resource']['Parameters'] = $this->data['WebService']['Options'] = unserialize(base64_decode(trim($this->config->get('mahaposts_options'))));
	}
	/*********************************************************/
	public function RegisterOrder() {
		$this->Connect();
		$json = array();
		/* Models */
		$this->load->model('checkout/order');
		$this->load->model('account/address');
		$this->load->model('account/customer');
		$this->load->model('localisation/weight');
		$this->load->model('localisation/currency');
		/* Language */
		$this->language->load('payment/mahacod_payment');
		/* OrderData */
		$getOrder = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		if ($this->customer->isLogged()) {
			$getShipping = $this->model_account_address->getAddress($this->session->data['shipping_address_id']);
			$getPayment = $this->model_account_address->getAddress($this->session->data['payment_address_id']);
		} else {
			$getGuest = $this->session->data['guest'];
			$getShipping = $this->session->data['guest']['shipping'];
			$getPayment = $this->session->data['guest']['payment'];
		}
		/* WeightData */
		$weights = $this->model_localisation_weight->getWeights();
		foreach ($weights as $code => $data) { if ($data['unit'] == 'g') { $weight = $code; break; } }
		/* getCart */
		$this->data['products'] = array();
		$counter = 1;
		$this->load->model('catalog/product');
		foreach ($this->cart->getProducts() as $product) {
			$product_info = $this->model_catalog_product->getProduct($product['product_id']);
			if ($product_info['mahacod_pid']==0){
				$new_pid = $this->WebService->data['Config']['Shop_id'].str_replace(" ","",$product['model']);
				if (empty($new_pid)){
					$new_pid = mt_rand(1,9);
					for ($i=0; $i<4; $i++){ $new_pid .= mt_rand(0,9); }
				}
				$this->db->query("UPDATE " . DB_PREFIX . "product SET mahacod_pid = '" . $new_pid . "', date_modified = NOW() WHERE product_id = '" . (int)$product_info['product_id'] . "'");
				$product_info['mahacod_pid']=$new_pid;
			}
			$this->data['products'][] = array(
				'mahacod_pid' => $product_info['mahacod_pid'],
				'key'       => $product['model'],
				'name'     => $product['name'] . ($product['model'] ? (" (" . $product['model'] . ") ") : ""),
				'model'    => $product['model'],
				'weight'   => $product['weight'],
				'quantity' => $product['quantity'],
				'stock'    => $product['stock'],
				'price'	   => $this->currency->format($this->tax->calculate($product['price'], $product['tax_class_id'], $this->config->get('config_tax')), $this->currency->getCode(), false, false),
				'total'    => $this->currency->format($this->tax->calculate($product['total'], $product['tax_class_id'], $this->config->get('config_tax')), $this->currency->getCode(), false, false),
				'tax_class_id'    => $product['tax_class_id'],
				'weight_class_id' => $product['weight_class_id'],
			);
			$counter++;
		}
		/* getOrder */
		if ($this->customer->isLogged()) {
			$Customer = array(
				/* Customer */
				'FirstName' => $getOrder['shipping_firstname'],
				'LastName'  => $getOrder['shipping_lastname'],
				'Company'   => $getOrder['shipping_company'],
				'Fax'       => $getOrder['fax'],
				'Mobile'	=> $getOrder['telephone'],
				'Telephone' => $getOrder['telephone'],
				'Email'     => $getOrder['email'],
				"Ip"		=> $getOrder['ip'],
				/* Shipping */
				'ZipCode'   => $getOrder['shipping_postcode'],
				'Address'   => $getOrder['shipping_address_1'] . (!empty($getOrder['shipping_address_2']) ? (' - ' . $getOrder['shipping_address_2']) : ''),
				//'ostan'	 => $this->data['WebService']['ostan_id'],
				//'shahrestan'=> $this->data['WebService']['shahrestan_id'],
				'Town' 	  => "No Town",
				/* Order */
				"Discount"	=> 1,
				"SendType"  => "pishtaz",
				"Payment"   => isset($this->session->data['payment_method']) ? $this->session->data['payment_method'] : '',
				"Shipping"  	=> isset($this->session->data['shipping_method']) ? $this->session->data['shipping_method'] : '',
				"Comment"   => empty($getOrder['comment']) ? "No Comment" : $getOrder['comment']
			);
			
		} elseif (isset($this->session->data['guest'])) {
			$Customer = array(
				/* Customer */
				'FirstName' => $getShipping['firstname'],
				'LastName'  => $getShipping['lastname'],
				'Company'   => $getShipping['company'],
				'Fax'       => $getGuest['fax'],
				'Mobile'	=> $getGuest['telephone'],
				'Telephone' => $getGuest['telephone'],
				'Email'     => $getGuest['email'],
				"Ip"		=> $getOrder['ip'],
				/* Shipping */
				'ZipCode'   => $getShipping['postcode'],
				'Address'   => $getShipping['address_1'] . (!empty($getShipping['address_2']) ? (' - ' . $getShipping['address_2']) : ''),
				//'ostan'	 => $this->data['WebService']['ostan_id'],
				//'shahrestan'=> $this->data['WebService']['shahrestan_id'],
				'Town' 	  => "No Town",
				/* Order */
				"Discount"  => 1,
				"SendType"  => "pishtaz",
				"Payment"   => isset($this->session->data['payment_method']) ? $this->session->data['payment_method'] : '',
				"Shipping"  => isset($this->session->data['shipping_method']) ? $this->session->data['shipping_method'] : '',
				"Comment"   => empty($getOrder['comment']) ? "No Comment" : $getOrder['comment']
			);
		} else {
			return (false);
		}
		if (isset($this->session->data['shipping_method']) && $this->session->data['shipping_method']['code'] == "mahacod_shipping.mahacod_express") { $Customer['SendType'] = 'pishtaz'; }
		if (isset($this->session->data['shipping_method']) && $this->session->data['shipping_method']['code'] == "mahacod_shipping.mahacod_registred") { $Customer['SendType'] = 'sefareshi'; }
		$Products = array();
		foreach ($this->data['products'] as $product) {
			$details = array(
				'mahacod_pid' => $product['mahacod_pid'],
				'Key'     => $product['key'],
				'Name'   => $product['name'],
				"Price" => $this->currency->convert($product['price'], $this->currency->getCode(), 'RLS'),
				'Total'  => $this->currency->convert($product['total'], $this->currency->getCode(), 'RLS'),
				'Weight' => $this->weight->convert(intval($product['weight']/$product['quantity']), $product['weight_class_id'], $weight),
				'WeightTotal' => $this->weight->convert(intval($product['weight']), $product['weight_class_id'], $weight),
				'Quantity' => $product['quantity'],
				'Discount_Type' => "0", /* percent = 0 - number = 1 */
				'Discount' => "0",
				'Percent' => "0"
			);
			if (empty($details['Weight'])) {
				/* Weight */
				$details['Weight'] = $this->config->get('mahaposts_default_product_weight');
			}
			$Products[] = (array)$details;
		}
		/* Data */
		$Data = array();
		/* RegisterOrder */		
		$this->data['WebService']['RegisterOrder'] = $this->WebService->RegisterOrder($Products, $Customer, $Data);
		if (count($this->WebService->errors) == 0) {
			$comment = '';
			$comment .= isset($this->data['WebService']['RegisterOrder']['TrakingCode']) && $this->data['WebService']['RegisterOrder']['TrakingCode'] ? ('Rahgiri (Tracking) Code: ' . $this->data['WebService']['RegisterOrder']['TrakingCode']) : "";
			$comment .= isset($this->data['WebService']['RegisterOrder']['OrderCode']) && $this->data['WebService']['RegisterOrder']['OrderCode'] ? ("\n" . 'Sefaresh (Factor) Code: ' . $this->data['WebService']['RegisterOrder']['OrderCode']) : "";
			## Confirm
			$this->model_checkout_order->confirm($getOrder['order_id'], $this->config->get('mahacod_payment_order_status_id'), $comment, true);
			## JsonSuccess
			$json['success'] = $this->url->link('checkout/success', '', 'SSL');
			$json['tracking_code'] = isset($this->data['WebService']['RegisterOrder']['TrakingCode']) && $this->data['WebService']['RegisterOrder']['TrakingCode'] ? $this->data['WebService']['RegisterOrder']['TrakingCode'] : '';
			$json['order_code'] = isset($this->data['WebService']['RegisterOrder']['OrderCode']) && $this->data['WebService']['RegisterOrder']['OrderCode'] ? $this->data['WebService']['RegisterOrder']['OrderCode'] : '';
			$json['language_tracking_code'] = $this->language->get('text_tracking_code');
			$json['language_order_code'] = $this->language->get('text_order_code');
			## EmptyCart
			if (isset($this->session->data['order_id'])) {
				$this->cart->clear();
				unset($this->session->data['shipping_method']);
				unset($this->session->data['shipping_methods']);
				unset($this->session->data['payment_method']);
				unset($this->session->data['payment_methods']);
				unset($this->session->data['guest']);
				unset($this->session->data['comment']);
				unset($this->session->data['order_id']);	
				unset($this->session->data['coupon']);
				unset($this->session->data['reward']);
				unset($this->session->data['voucher']);
				unset($this->session->data['vouchers']);
			}
		} else {
			## JsonError
			$json['error'] = implode(', ', $this->WebService->errors);
		}
		
		## Output
		$this->response->setOutput(json_encode($json));
	}
	/*********************************************************/
	public function get_post_price($type = 'pishtaz') {
		$this->load->model('localisation/weight');
		$this->load->model('localisation/currency');
		$weights = $this->model_localisation_weight->getWeights();
		foreach ($weights as $code => $data) {
			if ($data['unit'] == 'g') { $weight = $code; break; }
		}
		$data = array();
		$data['Total'] = $this->cart->getTotal();
		$data['Total'] = $this->currency->format($data['Total'], $this->currency->getCode(), false, false);
		$data['Total'] = $this->currency->convert($data['Total'], $this->currency->getCode(), 'RLS');
		$data['SendType'] = $type;
		$data['ostan_id'] = (isset($this->session->data['ostan_id'])) ? $this->session->data['ostan_id'] : '';
		$data['shahrestan_id'] = (isset($this->session->data['shahrestan_id'])) ? $this->session->data['shahrestan_id'] : '';
		$data['Weight'] = 0;
		foreach ($this->cart->getProducts() as $product) {
			$product['weight'] = empty($product['weight']) ? $this->config->get('mahaposts_default_product_weight') : $product['weight'];
			$data['Weight'] += $this->weight->convert($product['weight'], $product['weight_class_id'], $weight);
		}
		if (!empty($data['ostan_id'])){
			$this->Connect();
			$this->data['WebService']['get_post_price'] = $this->WebService->get_post_price($data);
		}else{$this->data['WebService']['get_post_price']=0;}
		$this->response->setOutput($this->data['WebService']['get_post_price']);
		return $this->data['WebService']['get_post_price'];
	}
	/*********************************************************/
	public function get_order_status() {
		$data['rahgiri_code'] = $this->request->get['rahgiri_code'] = isset($this->request->get['rahgiri_code']) ? $this->request->get['rahgiri_code'] : '';
		$this->Connect();
		$this->data['WebService']['get_order_status'] = $this->WebService->get_order_status($data);
		$this->response->setOutput($this->data['WebService']['get_order_status']);
		$this->response->output();
		$this->response->setOutput('');
	}
}
?>