<?php
require_once(DIR_SYSTEM . 'library/nuSoap/nusoap.php');

class ModelShippingmahacodShipping extends Model {
	protected $data = array();
	/*********************************************************/
	public function Connect() {
		$this->load->library('MahaCOD-CashOnDelivery/MahaCOD.class');
		$this->WebService = new Mahacod();
		$this->WebService->data['Config']['Shop_id'] = $this->data['WebService']['Shop_id'] = $this->config->get('mahaposts_co_id');
		$this->WebService->data['Config']['Username'] = $this->data['WebService']['Username'] = $this->config->get('mahaposts_username');
		$this->WebService->data['Config']['Password'] = $this->data['WebService']['Password'] = $this->config->get('mahaposts_password');
		$this->WebService->data['Resource']['Parameters'] = $this->data['WebService']['Options']= unserialize(base64_decode(trim($this->config->get('mahaposts_options'))));
	}
	/*********************************************************/
	public function get_post_price($type = 'pishtaz') {
		$this->load->model('localisation/weight');
		$this->load->model('localisation/currency');
		$weights = $this->model_localisation_weight->getWeights();
		foreach ($weights as $code => $data) { if ($data['unit'] == 'g') { $weight = $code; break; } }
		$data = array();
		$data['Total'] = $this->cart->getTotal();
		$data['Total'] = $this->currency->format($data['Total'], $this->currency->getCode(), false, false);
		$data['Total'] = $this->currency->convert($data['Total'], $this->currency->getCode(), 'RLS');
		$data['SendType'] = $type;
		$data['ostan_id'] = (isset($this->session->data['ostan_id'])) ? $this->session->data['ostan_id'] : '';
		$data['shahrestan_id'] = (isset($this->session->data['shahrestan_id'])) ? $this->session->data['shahrestan_id'] : '';
		$data['Weight'] = 0;
		foreach ($this->cart->getProducts() as $product) {
			$product['weight'] = empty($product['weight']) ? $this->config->get('mahaposts_default_product_weight') : $product['weight'];
			$data['Weight'] += $this->weight->convert($product['weight'], $product['weight_class_id'], $weight);
		}
		if (!empty($data['ostan_id'])){
			$this->Connect();
			$this->data['WebService']['get_post_price'] = $this->WebService->get_post_price($data);
		}else{$this->data['WebService']['get_post_price']=0;}
		return $this->data['WebService']['get_post_price'];
	}
	/*********************************************************/
	function getQuote($address) {
		$this->load->language('shipping/mahacod_shipping');
		$this->load->model('localisation/currency');
		$data = array();
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('mahacod_shipping_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
		$data['express'] = array('post_price' => $this->get_post_price('pishtaz'),'cost-1' => 0,'cost-2' => 0,'error' => false);
		$data['registred'] = array('post_price' => $this->get_post_price('sefareshi'),'cost-1' => 0,'cost-2' => 0,'error' => false);
		if (is_numeric($data['express']['post_price'])) {
			$data['express']['cost-1'] = $this->currency->convert($data['express']['post_price'], "RLS", "TOM");
			$data['express']['cost-2'] = $this->currency->convert($data['express']['post_price'], "RLS", $this->currency->getCode());
			$data['express']['cost-2'] = $this->currency->format($data['express']['cost-2'], $this->currency->getCode(), "1", true);
		} else {
			$data['express']['error'] = $data['express']['post_price'];
		}
		if (is_numeric($data['registred']['post_price'])) {
			$data['registred']['cost-1'] = $this->currency->convert($data['registred']['post_price'], "RLS", "TOM");
			$data['registred']['cost-2'] = $this->currency->convert($data['registred']['post_price'], "RLS", $this->currency->getCode());
			$data['registred']['cost-2'] = $this->currency->format($data['registred']['cost-2'], $this->currency->getCode(), "1", true);
		} else {
			$data['registred']['error'] = $data['registred']['post_price'];
		}
		if (!$this->config->get('mahacod_shipping_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}
		$method_data = array();
		if ($status) {	
			$quote_data = array();
			if (!$data['express']['error']) { 
				$quote_data['mahacod_express'] = array(
					'code'         => 'mahacod_shipping.mahacod_express',
					'title'        => $this->language->get('text_description_1'),
					'tax_class_id' => 0,
					'cost'         => $data['express']['cost-1'],
					'text'         => $data['express']['cost-2']
				);
			}
			if (!$data['registred']['error']) {
				$quote_data['mahacod_registred'] = array(
					'code'         => 'mahacod_shipping.mahacod_registred',
					'title'        => $this->language->get('text_description_2'),
					'tax_class_id' => 0,
					'cost'         => $data['registred']['cost-1'],
					'text'         => $data['registred']['cost-2']
				);
			}
      		$method_data = array(
        		'code'       => 'mahacod_shipping',
        		'title'      => $this->language->get('text_title'),
        		'quote'      => $quote_data,
				'sort_order' => $this->config->get('mahacod_shipping_sort_order'),
        		'error'      => false
      		);
		}
		return $method_data;
	}
}
?>